#!/usr/bin/perl -w

$confGmetric = "/usr/bin/gmetric --tmax=700";
$confGanglia = "/etc/gmond.conf";

die "Ganglia is not installed" if ! -r $confGanglia;

$ip   = "239.2.11.71";
$port = "8649";

open(IN,"$confGanglia") || die "Cannot read $confGanglia";
while (<IN>)
  {
    next if /^#/;
    $ip   = $1 if /mcast_channel +(.*)/;
    $port = $1 if /mcast_port +(.*)/;
  }
close IN;

$ENV{"TERM"} = "vt100";

my @top = split(/\n/,`top -b -n1`);

while(1)
  {
    $t = shift @top;
    last if ! defined $t;
    last if ($t =~ /^\s+PID/);
  }

for (my $i=1; ; $i++)
  {
    my $t = shift @top;
    last if ! $t;
    $t =~ s/^ *//; # remove leading spaces
    my @t = split(/ +/,$t);

    my $user = $t[1];
    my $size = $t[4];
    my $rss  = $t[5];
    my $cmd  = pop @t;
    my $time = pop @t;
    $time = pop @t if !($time =~ /\:/);
    my $mem  = pop @t;
    my $cpu  = pop @t;

    if (1)
      {
        if (uc($size) =~ /(.*)M/)
          {
            my $xsize = $1;
            $size = $xsize*1024;
          }

        if (uc($rss) =~ /(.*)M/)
          {
            my $xsize = $1;
            $rss = $xsize*1024;
          }

        $size = int(($size+1023)/1024);
        $rss  = int(($rss+1023)/1024);

        my $val  = "$user/$size"."M/".$rss."M/$cmd";

        $val =~ s/\</[/g;
        $val =~ s/\>/]/g;

        $mem{$val} = $size;
      }

    if ($i <= 5)
      {
        my $val  = "$user/$cpu/$time/$cmd";

        $val =~ s/\</[/g;
        $val =~ s/\>/]/g;
        
        my $exec = "$confGmetric -c$ip -p$port -tstring -n\"top_$i\" -v\"$val\"";
        #print "$exec\n";
        system $exec;
      }
  }

my $i = 0;
foreach my $mem (sort { $mem{$b} <=> $mem{$a} } keys %mem)
  {
    $i++;
    #print "mem_$i $mem\n";

    if ($i <= 5)
      {
        my $exec = "$confGmetric -c$ip -p$port -tstring -n\"mem_$i\" -v\"$mem\"";
        #print "$exec\n";
        system $exec;
      }
  }

exit 0;
#end file
